#lang racket

(require "monad.rkt")
(require "common-types.rkt")

(define-syntax-rule (return e)
  (#%app (monad-return (current-monad)) e))

;; (All (C D)
;;  (EL (C -> (EL D))) (Listof JP) (Listof Aspect)
;;   ->
;;  (EL (C -> (EL D))))
(define (weave fun-val jp* aspects aspect-pc aspect-adv)
  (foldr
   (lambda (aspect proceed)
     (untyped-do
      (proceed-fun <- proceed)
      (pointcut-result <- ((aspect-pc aspect) jp*))
      (if pointcut-result
          (return
           (lambda (arg)
             (untyped-do
              (let ((advice ((aspect-adv aspect) proceed-fun)))
                (advice arg)))))
          (return proceed-fun))))
   fun-val
   aspects))

;; (All (A B) ((A -> (EL B)) A -> (EL B)))
(define (app/weave/rt fun arg-vals jp-context current-aspects Aspect-pc Aspect-adv)
  (untyped-do       
   (weaving-result <- (weave (return fun)
                             (jp-context)
                             (current-aspects)
                             Aspect-pc
                             Aspect-adv))
   (weaving-result arg-vals)))

(define-syntax untyped-do
  (syntax-rules (lambda let let* letrec letrec* <- $)
    ((untyped-do s) s)
    ((untyped-do (x <- s) ss ...) ((monad-bind (current-monad)) s (lambda (x) (untyped-do ss ...))))
    ((untyped-do (let bs) ss ...) (let bs (untyped-do ss ...)))
    ((untyped-do (let* bs) ss ...) (let* bs (untyped-do ss ...)))
    ((untyped-do (letrec bs) ss ...) (letrec bs (untyped-do ss ...)))
    ((untyped-do (letrec* bs) ss ...) (letrec* bs (untyped-do ss ...)))
    ((untyped-do s ss ...) ((monad-bind (current-monad)) s (lambda (_) (untyped-do ss ...))))))

(provide (rename-out [weave untyped-weave]
                     [app/weave/rt untyped-app/weave/rt]))